<?php

@set_time_limit(0);

function CheckAbilityOfInstallation()
{
  $result['Success'] = 1;
  $result['ErrorMessage'] = '!';

  // check if all files are writeable
  $files = file($GLOBALS['TMP_FOLDER']."files.txt");

  // add check for module files
  global $db, $MODULE_FOLDER, $TMP_FOLDER;
  $installed_modules = $db->get_results("SELECT Keyword FROM Module", ARRAY_A);
  foreach ((array)$installed_modules as $module)
  {
    if (file_exists($MODULE_FOLDER.$module['Keyword']))
    {
       $module_files = nc_installer_filelist($TMP_FOLDER."modules/$module[Keyword]");
       foreach ((array)$module_files as $module_file) {
         $files[] = "/netcat/modules/$module[Keyword]/$module_file";
       }
     }

  }

  foreach ($files as $file)
  {
     $file = $GLOBALS['DOCUMENT_ROOT'].rtrim($file);
     if (file_exists($file))
     {
        if (!is_writable($file) && !@chmod($file, 0777)) // file is not writable
        {
           $result['ErrorMessage'] = "<b>         netcat.</b><br><small>($file   )</small>";
           $result['Success'] = 0;
        }
     }
     else // check dir
     {
        $dirname = dirname($file);
        // find the nearest existing parent directory
        while (!file_exists($dirname))
        {
           $dirname = preg_replace("!/[^/]+$!", "", $dirname);
           if ($dirname=="$GLOBALS[DOCUMENT_ROOT]/netcat") break;
        }

        if (!is_writable($dirname) && !@chmod($dirname, 0777)) // directory is not writable
        {
           $result['ErrorMessage'] = "<b>      $GLOBALS[DOCUMENT_ROOT]/netcat   .</b><br><small>($dirname   )</small>";
           $result['Success'] = 0;
        }
     }
  }

  return $result;
}

function InstallPatch() {

  global $TMP_FOLDER, $MODULE_FOLDER, $ROOT_FOLDER, $db;
  $TMP_FOLDER = str_replace("//", "/", $TMP_FOLDER);

  $result['Success'] = 1;
  $result['ErrorMessage'] = '!';

  // update modules
  $installed_modules = $db->get_results("SELECT Keyword FROM Module WHERE Keyword IN ('auth','captcha','forum','netshop','search')", ARRAY_A);
  foreach ((array)$installed_modules as $module) {

    // Execute SQL, if any
    if (file_exists($TMP_FOLDER."modules/$module[Keyword].sql")) {
       ExecSQL($TMP_FOLDER."modules/$module[Keyword].sql");
    }

    // Copy all files to modules folder
    nc_installer_copy_all($TMP_FOLDER."modules/$module[Keyword]", $MODULE_FOLDER.$module["Keyword"]);

    // include script if necessary
    if (file_exists($TMP_FOLDER."modules/$module[Keyword].inc.php")) {
      include($TMP_FOLDER."modules/$module[Keyword].inc.php");
    }

    // Remove old files
    if (file_exists($TMP_FOLDER."modules/$module[Keyword].remove")) {

      $files_to_remove = file($TMP_FOLDER."modules/$module[Keyword].remove");

      foreach ($files_to_remove as $file) {
        $file = trim($file,"\r\n/");
        if (is_dir($ROOT_FOLDER.$file)) { @rmdir($ROOT_FOLDER.$file); }
                                   else { @unlink($ROOT_FOLDER.$file); }

      }
    }
  }

  return $result;
}

function nc_installer_copy_all($from, $to) {

    $from = str_replace("//", "/", $from);
    $to = str_replace("//", "/", $to);
    $dh = opendir($from);
    if (!$dh) return;

    while (false !== ($file = readdir($dh))) {
      if ($file=="." || $file=="..") continue;
      if (is_dir("$from/$file")) {
        @mkdir("$to/$file", 0755);
        nc_installer_copy_all("$from/$file", "$to/$file");
      }
      else {
        copy("$from/$file", "$to/$file");
      }
    }

    closedir($dh);
}


function nc_installer_filelist($dir) {
    static $level;
    static $start_dir;

    $dir = str_replace("//", "/", $dir);
    if (!$level) $start_dir = $dir;

    $ret = array();
    $dh = @opendir($dir); // non-existent dir may be passed

    if (!$dh) return $ret;
    $level++;

    while (false !== ($file = readdir($dh))) {
      if ($file=="." || $file=="..") continue;
      if (is_dir("$dir/$file")) {
        $ret = array_merge($ret, nc_installer_filelist("$dir/$file"));
      }
      else {
        $ret[] = preg_replace("!^$start_dir/!", "", "$dir/$file");
      }
    }

    closedir($dh);
    $level--;
    return $ret;
}

?>