<?php
/*
 * FCKeditor - The text editor for internet
 * Copyright (C) 2003-2005 Frederico Caldeira Knabben
 *
 * Licensed under the terms of the GNU Lesser General Public License:
 * 		http://www.opensource.org/licenses/lgpl-license.php
 *
 * For further information visit:
 * 		http://www.fckeditor.net/
 *
 * "Support Open Source software. What about a donation today?"
 *
 * File Name: upload.php
 * 	This is the "File Uploader" for PHP.
 *
 * File Authors:
 * 		Frederico Caldeira Knabben (fredck@fckeditor.net)
 */

require('config.php') ;
require('util.php') ;

require("../../../../../vars.inc.php");
require("../../../../../connect_io.php");

require($ADMIN_FOLDER."auth.inc.php");

if (!isset($AUTHORIZE_BY))
{
	$AUTHORIZE_BY = 'User_ID';
}

if ($AUTHORIZATION_TYPE == 'cookie')
{
	$PHP_AUTH_PW = $_COOKIE['PHP_AUTH_PW'];
    if (isset($_COOKIE['PHP_AUTH_USER']) && !isset($_COOKIE['PHP_AUTH_PW']))
    {
        $PHP_AUTH_PW = "";
    }
    $PHP_AUTH_USER = $_COOKIE['PHP_AUTH_USER'];

}
elseif ($AUTHORIZATION_TYPE == 'session')
{
    session_start();
    if (!isset($_SESSION['User']))
    exit;
    $PHP_AUTH_USER = $_SESSION['User']['PHP_AUTH_USER'];
    $PHP_AUTH_PW = $_SESSION['User']['PHP_AUTH_PW'];
}
elseif ($AUTHORIZATION_TYPE == 'http')
{
	if (!$_SERVER['PHP_AUTH_USER']){
            Header ("WWW-authenticate:  basic  realm=Enter your login and password");
            Header ($_SERVER['SERVER_PROTOCOL'].' 401  Unauthorized');
	}
	else {
	   $PHP_AUTH_USER = $_SERVER['PHP_AUTH_USER'];
	   $PHP_AUTH_PW = $_SERVER['PHP_AUTH_PW'];
	}
}
elseif ($AUTHORIZATION_TYPE != 'http')
{
    $PHP_AUTH_USER = $AUTH_USER;
    $PHP_AUTH_PW = $AUTH_PW;
}


    $user = $db->get_row("SELECT a.User_ID,a.PermissionGroup_ID, b.AdminType,b.PermissionSet FROM User as a, Permission as b WHERE a.{$AUTHORIZE_BY}='{$PHP_AUTH_USER}' AND a.Password=".($AUTHORIZATION_TYPE!='http'?"'".$PHP_AUTH_PW."'":"PASSWORD('".$PHP_AUTH_PW."')")." AND (a.User_ID=b.User_ID OR a.PermissionGroup_ID=b.PermissionGroup_ID)");


	if (!$user->User_ID)
	{
		SendError( 1, 'Not enough rights or Hack attempt!' ) ;
		exit;
	}

	$permTmp = new Permission ($user->User_ID, $user->PermissionGroup_ID, 0);

	# check Guest
	if ($permTmp->isGuest())
	{
		SendError( 1, 'Not enough rights or Hack attempt!' ) ;
		exit;
	}

	$perm_count = $db->get_var("SELECT COUNT(*) as cnt FROM Permission");

	# check Site, Sub, Sub_Class
	$ReturnValue = 0;
	for ($i=0; $i < $perm_count; $i++) {
		if ( ($permTmp->ARRAY[CATALOGUE_ADMIN][$i][2] & 32) || ($permTmp->ARRAY[CATALOGUE_ADMIN][$i][2] & 16) || ($permTmp->ARRAY[CATALOGUE_ADMIN][$i][2] & 4) || ($permTmp->ARRAY[CATALOGUE_ADMIN][$i][2] & 2) || ($permTmp->ARRAY[SUBDIVISION_ADMIN][$i][2] & 32) || ($permTmp->ARRAY[SUBDIVISION_ADMIN][$i][2] & 16) || ($permTmp->ARRAY[SUBDIVISION_ADMIN][$i][2] & 4) || ($permTmp->ARRAY[SUBDIVISION_ADMIN][$i][2] & 2) || ($permTmp->ARRAY[SUB_CLASS_ADMIN][$i][2] & 32) || ($permTmp->ARRAY[SUB_CLASS_ADMIN][$i][2] & 16) || ($permTmp->ARRAY[SUB_CLASS_ADMIN][$i][2] & 4) || ($permTmp->ARRAY[SUB_CLASS_ADMIN][$i][2] & 2)) {
			$ReturnValue = 1;
			break;
         }
	}

	#check SuperRights
	if (!$ReturnValue && !$permTmp->isSupervisor() && !$permTmp->isManager() && !$permTmp->isDirector())
	{
		SendError( 1, 'Not enough rights or Hack attempt!' ) ;
		exit;
	}

// This is the function that sends the results of the uploading process.
function SendResults( $errorNumber, $fileUrl = '', $fileName = '', $customMsg = '' )
{
	echo '<script type="text/javascript">' ;
	echo 'window.parent.OnUploadCompleted(' . $errorNumber . ',"' . str_replace( '"', '\\"', $fileUrl ) . '","' . str_replace( '"', '\\"', $fileName ) . '", "' . str_replace( '"', '\\"', $customMsg ) . '") ;' ;
	echo '</script>' ;
	exit ;
}

// Check if this uploader has been enabled.
if ( !$Config['Enabled'] )
	SendResults( '1', '', '', 'This file uploader is disabled. Please check the "editor/filemanager/upload/php/config.php" file' ) ;

// Check if the file has been correctly uploaded.
if ( !isset( $_FILES['NewFile'] ) || is_null( $_FILES['NewFile']['tmp_name'] ) || $_FILES['NewFile']['name'] == '' )
	SendResults( '202' ) ;

// Get the posted file.
$oFile = $_FILES['NewFile'] ;

// Get the uploaded file name and extension.
$sFileName = $oFile['name'] ;

//kx::: try to cleanup extension (dot, #0 etc)
$sFileName = preg_replace("/\W+$/", "", $sFileName);
// -------------------------------------------

$sOriginalFileName = $sFileName ;
$sExtension = substr( $sFileName, ( strrpos($sFileName, '.') + 1 ) ) ;
$sExtension = strtolower( $sExtension ) ;

// The the file type (from the QueryString, by default 'File').
$sType = isset( $_GET['Type'] ) ? $_GET['Type'] : 'File' ;

// Get the allowed and denied extensions arrays.
$arAllowed	= $Config['AllowedExtensions'][$sType] ;
$arDenied	= $Config['DeniedExtensions'][$sType] ;

// Check if it is an allowed extension.
if ( ( count($arAllowed) > 0 && !in_array( $sExtension, $arAllowed ) ) || ( count($arDenied) > 0 && in_array( $sExtension, $arDenied ) ) )
	SendResults( '202' ) ;

$sErrorNumber	= '0' ;
$sFileUrl		= '' ;

// Initializes the counter used to rename the file, if another one with the same name already exists.
$iCounter = 0 ;

// The the target directory.
$sServerDir = GetRootPath() . $Config["UserFilesPath"] ;

while ( true )
{
	// Compose the file path.
	$sFilePath = $sServerDir . $sFileName ;

	// If a file with that name already exists.
	if ( is_file( $sFilePath ) )
	{
		$iCounter++ ;
		$sFileName = RemoveExtension( $sOriginalFileName ) . '(' . $iCounter . ').' . $sExtension ;
		$sErrorNumber = '201' ;
	}
	else
	{
		move_uploaded_file( $oFile['tmp_name'], $sFilePath ) ;

		if ( is_file( $sFilePath ) )
		{
			$oldumask = umask(0) ;
			chmod( $sFilePath, 0777 ) ;
			umask( $oldumask ) ;
		}

		$sFileUrl = $Config["UserFilesPath"] . $sFileName ;

		break ;
	}
}

SendResults( $sErrorNumber, $sFileUrl, $sFileName ) ;
?>